#include <math.h>
#include <stdio.h>

/*
program to test the output of program drift for zero mean.
*/

#define N 10

int main(int argc, char* argv[])
{
  int n=N,t[2*N+1],*at,i,j,ni,tot;
  double m,s,z;
  FILE* f;

  if (argc != 2)
    {
      puts("");
      puts("the program needs a file generated by program drift as argument");
      puts("example:");
      puts("./taz 16.res\n");
      exit(1);
    }

  at=t+N;
  for (j=-n; j<=n; j++) at[j]=0;

  f=fopen(argv[1],"r");
  if (f == NULL) {printf("cannot open %s\n",argv[1]); exit(1);}
  while(fscanf(f,"%d %d",&i,&ni) != EOF)
  {
    if (abs(i) > N) {printf("error: i: %d\n",i); exit(1);}
    at[i]=ni;
  }
  fclose(f);

  tot=0;
  m=0;
  for (j=-n; j<=n; j++) {tot += at[j]; m += j*at[j];}
  m /= tot;
  s=0;
  for (j=-n; j<=n; j++) s += (j-m)*(j-m)*at[j];
  s=sqrt(s)/tot;
  z=m/s;

  printf("statistic: %15.10f\n",z);

  return(0);
}
